@use '../../../global/styles/utilities' as *;
@use '../../../global/styles/breakpoint';
@use '../../../global/styles/border';
@use '../../../design-tokens/scss/variables';

:host {
	.digi-form-file-upload {
		--digi--form-file-upload--background: var(--digi--color--background--secondary);
		--digi--form-file-upload--background--hover: var(--digi--color--background--tertiary);
		--digi--form-file-upload--files-background: var(--digi--color--background--informative);
		--digi--form-file-upload--border-color: var(--digi--color--border--secondary);
		--digi--form-file-upload--border-color--hover: var(--digi--color--border--primary);
		--digi--form-file-upload--border-style: dashed;
		--digi--form-file-upload--border-width: 2px;

		digi-form-label {
			margin-block-end: var(--digi--gutter--small);
			display: block;
		}

		&__upload-button {
			--digi--button--font-weight: regular;
			--digi--button--font-size--medium: var(--digi--global--typography--font-size--large);

			@include breakpoint.below-medium {
				--digi--button--padding--medium: var(--digi--gutter--button-block-medium) var(--digi--gutter--button-inline-medium) 0 var(--digi--gutter--button-inline-medium);
				--digi--height--button-small: 0;
			}
		}

		&__spinner {
			animation: animation__rotation 0.5s * 6 infinite linear;
			transform-origin: center;
			--digi--icon--height: #{rem(16)};

			@media (prefers-reduced-motion) {
				animation: none;
			}

			@keyframes animation__rotation {
				from {
					transform: rotate(0deg);
				}

				to {
					transform: rotate(359deg);
				}
			}
		}

		&__input {
			display: none;
		}

		&__upload-text {
			@include breakpoint.below-medium {
				display: none;
			}
		}

		&__button {
			margin-top: auto;
			text-align: center;
			background: none;
			border: none;
			cursor: pointer;
			margin: 0;
			font-size: var(--digi--typography--body--font-size--desktop);
			display: flex;
			align-items: center;
			font-family: var(--digi--global--typography--font-family--default);

			&:focus {
				border-color: var(--digi--global--color--function--info--base);
			}

			&-icon {
				width: 20px;
				height: 20px;
				margin-left: 5px;
			}

			&--mobile {
				@include breakpoint.medium {
					display: none;
				}
			}
		}

		&__upload-area {
			display: flex;
			flex-direction: column;
			//background-color: var(--digi--form-file-upload--background);
			align-items: center;
			padding: var(--digi--padding--small);
			margin-bottom: var(--digi--gutter--medium);
			position: relative;
			cursor: pointer;
			background: border.dashed(variables.$digi--color--border--secondary) var(--digi--form-file-upload--background);

			@include breakpoint.medium {
				padding: var(--digi--padding--largest);
			}

			&--hover {
				background: border.dashed(variables.$digi--color--border--primary) var(--digi--form-file-upload--background--hover);
			}

			&-overlay {
				position: absolute;
				width: 100%;
				height: 100%;
				background-color: #000;
				opacity: 0.05;
				top: 0;
				left: 0;
				z-index: 10;
			}
		}

		&__text-area {
			display: flex;
			flex-direction: column;
			align-items: center;
			justify-content: center;
			text-align: center;
		}

		&__files {
			max-width: 100%;
			background-color: var(--digi--form-file-upload--files-background);
			padding: var(--digi--gutter--largest-2) var(--digi--padding--large);
			margin-bottom: var(--digi--gutter--medium);
			margin-top: var(--digi--gutter--medium);
			padding-bottom: var(--digi--padding--smaller);

			ul {
				max-width: none;
				padding: 0;
				margin: 0;
			}

			h4 {
				margin: 0;
				padding: 0;
				font-weight: var(--digi--typography--body--font-weight--desktop);
			}
		}

		&__files-heading {
			font-family: var(--digi--global--typography--font-family--default);
			font-size: var(--digi--typography--heading-4--font-size--desktop);
			font-weight: var(--digi--global--typography--font-weight--semibold);
			color: var(--digi--color--text--primary);
			margin: 0;
			display: block;

			@include breakpoint.large {
				font-size: var(--digi--typography--heading-4--font-size--desktop-large);
			}
		}

		&__file {
			padding: var(--digi--gutter--medium) 0 var(--digi--gutter--small);

			&-container {
				list-style-type: none;

				&:nth-child(n + 2) {
					border-top: border.$list;
				}
			}

			&-header {
				display: flex;
				align-items: center;
				justify-content: space-between;
			}

			&-header-name-container {
				display: flex;
				align-items: center;
				gap: 22px;
			}

			&-header-icon {
				--digi--icon--height: 20px;
			}

			&-header-icon--success {
				--digi--icon--color: var(--digi--global--color--function--success--base);
			}

			&-footer {
				padding-left: 30px;
			}

			&-name {
				overflow: hidden;
				text-overflow: ellipsis;
				max-width: 18.75rem;
				white-space: nowrap;
				height: max-content;
				margin: 0 auto 0 0;
				padding: 0;

				@include breakpoint.below-medium {
					max-width: 12.75rem;
				}
			}

			&-icon {
				display: flex;
				justify-content: center;
				align-items: center;
			}

			&-info {
				width: 100%;
			}

			span {
				height: max-content;
				margin-left: var(--digi--margin--smaller);

				@include breakpoint.below-medium {
					margin-left: 0;
					margin-right: auto;
				}
			}

			&-button {
				margin-left: auto;
				font-weight: var(--digi--global--typography--font-weight--semibold);
			}

			&--error {
				display: flex;
				color: red;

				@include breakpoint.below-medium {
					span {
						display: none;
					}
				}
			}
		}

		&__error {
			color: var(--digi--color--icons--danger);
		}
	}

	.visually-hidden {
		@include digi--a11y--sr-only;
	}

	.hidden-mobile {
		@include breakpoint.below-medium {
			display: none;
		}
	}
}
